/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.pprun.sample.jms.listener;

import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.jms.support.converter.MessageConversionException;

/**
 *
 * @author pprun
 */
public class SimpleListener implements MessageListener {

    private static final Log log = LogFactory.getLog(SimpleListener.class);

    @Override
    public void onMessage(Message message) {
        try {
            if (message instanceof TextMessage) {
                log.info("----------------------");
                log.info(((TextMessage) message).getText());
                log.info("----------------------");

            } else if (message instanceof MapMessage) {
                MapMessage msg = (MapMessage) message;
                log.info("----------------------");
                log.info(msg.getString("lastname"));
                log.info(msg.getString("firstname"));
                log.info(msg.getString("id"));
                log.info("----------------------");
            } else {
                throw new UnsupportedOperationException("Message Type has not supported yet.");
            }
        } catch (JMSException ex) {
            log.error("cannot convert the message", ex);
            throw new MessageConversionException("cannot convert the message", ex);
        }
    }
}
