/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.pprun.sample.jms.producer;

import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.jms.core.MessageCreator;

/**
 *
 * @author pprun
 */
public class JmsTopicSender {

    private JmsTemplate jmsTemplate;
    private Topic topic;

    public void setConnectionFactory(ConnectionFactory cf) {
        this.jmsTemplate = new JmsTemplate(cf);
    }

    public void setTopic(Topic topic) {
        this.topic = topic;
    }

    public void simpleSend(final String text) {
        this.jmsTemplate.send(this.topic, new MessageCreator() {

            @Override
            public Message createMessage(Session session) throws JMSException {
                if (text == null) {
                    MapMessage message = session.createMapMessage();
                    message.setString("lastname", "Pi");
                    message.setString("firstname", "Pprun");
                    message.setString("id", "1111");
                    return message;
                } else {
                    TextMessage message = session.createTextMessage();
                    message.setText(text);
                    return message;
                }
            }
        });
    }
}
